#!/usr/bin/perl -wT
use strict;

my $input = $ENV{REQUEST_URI};

my $result;
if ($input =~ m|/tests/adhoc/uri/encoding/results.cgi/(.+)\?(.+)$|os) {
    my $path = $1;
    my $query = $2;
    my $pathEncoding = recognise($path);
    my $queryEncoding = recognise($query);
    $result = "Path component:\n  $pathEncoding\n\nQuery component:\n  $queryEncoding\n";
} elsif ($input =~ m|/tests/adhoc/uri/encoding/results.cgi/(.+)$|os) {
    my $path = $1;
    my $pathEncoding = recognise($path);
    my $queryEncoding = "missing";
    $result = "Path component:\n  $pathEncoding\n\nQuery component:\n  $queryEncoding\n";
} else {
    $result = "Couldn't parse result.";
}

print "Content-Type: text/plain; charset=utf-8\r\n\r\nRESULTS\n\n$result";


sub recognise {
    my($input) = @_;
    # S-caron:
    return "%-escaped ISO-8859-13" if lc $input eq '%de';
    return "%-escaped ISO-8859-10" if lc $input eq '%ac';
    return "%-escaped ISO-8859-2" if lc $input eq '%ae';
    return "%-escaped ISO-8859-15" if lc $input eq '%b4';
    return "%-escaped Windows-1252" if lc $input eq '%8e';
    return "%-escaped UTF-8" if lc $input eq '%c5%bd';
    return "raw ISO-8859-13" if length $input == 1 and ord $input == 0xde;
    return "raw ISO-8859-10" if length $input == 1 and ord $input == 0xac;
    return "raw ISO-8859-2" if length $input == 1 and ord $input == 0xae;
    return "raw ISO-8859-15" if length $input == 1 and ord $input == 0xb4;
    return "raw Windows-1252" if length $input == 1 and ord $input == 0x8e;
    return "raw UTF-8" if length $input == 2 and ord substr($input, 0, 1) == 0xc5 and ord substr($input, 1, 1) == 0xbd;

    # Smiley:
    return "%-escaped UTF-8" if lc $input eq '%e2%98%ba';
    return "%-escaped ASCII &#9786;" if lc $input eq '%26%239786%3b';
    return "raw UTF-8" if length $input == 3 and ord substr($input, 0, 1) == 0xe2 and ord substr($input, 1, 1) == 0x98 and ord substr($input, 2, 1) == 0xba;

    # Either:
    return "raw question mark" if lc $input eq '?';

    return "unknown encoding (raw text: '$input')";
}
